# calculate all unique! divider

# import
import matplotlib.pyplot as plot

# constants
N = 10**8
SCALE = 1000

# calculate
teiler = [0 for i in range(0, N)]

for i in range(2, N):
    if not teiler[i]:
        for j in range(i, N, i):
            teiler[j] += 1

    if i % (N / 10) == 0:
        print('.', end='')

# count per interval
x_axis = range(0, N, int(N/SCALE))
counter = [[0 for i in x_axis] for i in range(10)]
interval = -1

for i in range(0, N):
    interval = int(i / (N/SCALE))
    t = teiler[i]
    counter[t][interval] += 1

# prepare visual
ax = plot.figure().add_subplot(111)
ax.set_xlim([0, N])
ax.set_ylim([0, int(N/SCALE/2)])

ax.set_xlabel('n')
ax.set_ylabel('Anzahl pro Intervall für ein bestimmten $\omega$')

for i, c in enumerate(counter):
    if c[-1] and i > 0:
        ax.plot(x_axis, c, '-', label='line %s' % j)
        ax.text(x_axis[-1]*1.01, c[-1], '$\omega$ = %s' % i)

plot.show()
