# calculate all unique! divider

# import
import matplotlib.pyplot as plot

# constants
N = 10**2
SCALE = 100

# calculate
teiler = [0 for i in range(0, N)]

for i in range(2, N):
    if not teiler[i]:
        for j in range(i, N, i):
            teiler[j] += 1

    if i % (N / 10) == 0:
        print('.', end='')

# count per interval
x_axis = range(0, N, int(N/SCALE))
counter = [[0 for i in x_axis] for i in range(10)]
interval = -1

for i in range(0, N):
    interval = int(i / (N/SCALE))
    t = teiler[i]
    counter[t][interval] += 1

# prepare visual
ax = plot.figure().add_subplot(111)
ax.set_xlim([0, N])
ax.set_ylim([0, 5])

ax.set_xlabel('n')
ax.set_ylabel(r'$\omega$')


for i, c in enumerate(teiler):
    if i>=2:
        ax.plot(i, c, 'o', label='line %s' % j, c="blue", mec="blue")

plot.show()
